/** I N C L U D E S **********************************************************/

#include <p18cxxx.h>
#include "io_cfg.h"
#include "system\typedefs.h"
#include "user\pk_isr.h"
#include "pickit.h"


/** V A R I A B L E S ********************************************************/



/** P R I V A T E  P R O T O T Y P E S ***************************************/


/** D E C L A R A T I O N S **************************************************/

#pragma code

/******************************************************************************
 * Function:        
 *
 * PreCondition:    None
 *
 * Input:           None
 *
 * Output:          None
 *
 * Side Effects:    None
 *
 * Overview:        
 *
 * Note:            Refer to PIC18F2455/2550/4455/4550 Errata concerning
 *                  high-priority interrupt problem.
 *   
 *****************************************************************************/

#pragma interruptlow InterruptHandler

void InterruptHandler (void)
{

	if (PIR1bits.TXIF)
	{
		if (downloadbuf_mgmt.used_bytes==0) 
		{
			PIE1bits.TXIE = 0;				// Disable UART transmit IT
			Status.DownLoadEmpty = 1;
		}
		else
		{
			TXREG = ReadDownloadBuffer();		
		}
	}

		
	if (PIR1bits.RCIF)
	{
		if ((RCSTA & 0x06)==0)
		{
			WriteUploadBuffer(RCREG);
		}
		else
		{
			RCSTAbits.CREN = 0;
			RCSTAbits.CREN = 1;
		}
	}
    

} // end void InterruptHandler(void)

#pragma code


